VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} Freq 
   Caption         =   "Generate Frequency Table"
   ClientHeight    =   7320
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3600
   OleObjectBlob   =   "Freq.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "Freq"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private m_pTable As ITable
Private m_iNumSortFields As Long
Private m_SortFNames() As String
Private m_iNumSumFields As Long
Private m_SumFNames() As String
Private m_OutFNames

Private Sub btnGetFields_Click()
   
   Dim pDoc As IMxDocument
   Dim pSelItem As IUnknown
   Dim pTable As ITable
   
   ' Check for selected table or feature class
   
   Set m_pTable = Nothing
   lbFields.Clear
   lbSortFields.Clear
   lbSummaryFields.Clear
   
   Set pDoc = ThisDocument
   Set pSelItem = pDoc.SelectedItem
   If pSelItem Is Nothing Then
      MsgBox "Nothing selected", vbExclamation
      Exit Sub
   ElseIf TypeOf pSelItem Is IStandaloneTable Or TypeOf pSelItem Is IFeatureLayer Then
      Set pTable = pSelItem
   Else
      MsgBox "No table selected", vbExclamation
      Exit Sub
   End If
   
   ' Populate field list
   
   Dim pFields As ITableFields
   Dim i As Long
   Dim pInfo As IFieldInfo
   Dim pField As iField
   Dim fType As esriFieldType
   
   Set pFields = pTable
   For i = 0 To pFields.FieldCount - 1
      Set pInfo = pFields.FieldInfo(i)
      If pInfo.Visible Then
         
         ' Check for supported field type
         
         Set pField = pTable.Fields.Field(i)
         fType = pField.Type
         If Not (fType = esriFieldTypeBlob Or _
            fType = esriFieldTypeGeometry Or _
            fType = esriFieldTypeRaster) Then
            
            lbFields.AddItem pField.Name
         
         End If
      End If
   Next
   If lbFields.ListCount = 0 Then
      MsgBox "No valid fields", vbExclamation
      Exit Sub
   End If

   Set m_pTable = pTable

End Sub

Private Sub btnAddSortField_Click()

   If m_pTable Is Nothing Then
      MsgBox "No table selected", vbExclamation
      Exit Sub
   End If
   
   ' Field should always be a valid sort field
   
   Dim FName As String
   FName = lbFields.Value
   lbSortFields.AddItem FName

End Sub

Private Sub btnAddSummaryField_Click()
   
   If m_pTable Is Nothing Then
      MsgBox "No table selected", vbExclamation
      Exit Sub
   End If
   
   ' Check if field is valid summary field
   
   Dim FName As String
   Dim i As Long
   Dim pField As iField
   FName = lbFields.Value
   Dim fType As esriFieldType
   i = m_pTable.Fields.FindField(FName)
   Set pField = m_pTable.Fields.Field(i)
   fType = pField.Type
   If Not (fType = esriFieldTypeDouble Or _
           fType = esriFieldTypeInteger Or _
           fType = esriFieldTypeSingle Or _
           fType = esriFieldTypeSmallInteger) Then
      MsgBox "Invalid field type", vbExclamation
      Exit Sub
   End If
   
   lbSummaryFields.AddItem FName

End Sub

Private Sub btnClear_Click()

   lbSortFields.Clear
   lbSummaryFields.Clear

End Sub

Private Sub btnDoIt_Click()

   If m_pTable Is Nothing Then
      MsgBox "No table selected", vbExclamation
      Exit Sub
   End If
   
   ' Get sort and summary field(s)
      
   Dim FieldString As String
   Dim i As Long, n As Long, iField As Long
   
   m_iNumSortFields = lbSortFields.ListCount
   If m_iNumSortFields = 0 Then
      MsgBox "No sort field(s) selected", vbExclamation
      Exit Sub
   End If
   m_iNumSumFields = lbSummaryFields.ListCount
   Erase m_SortFNames
   Erase m_SumFNames
   
   FieldString = ""
   n = 0
   For i = 0 To m_iNumSortFields - 1
      iField = m_pTable.Fields.FindField(lbSortFields.List(i))
      FName = m_pTable.Fields.Field(iField).Name
      ReDim Preserve m_SortFNames(n)
      m_SortFNames(n) = FName
      If FieldString = "" Then
         FieldString = FName
      Else
         FieldString = FieldString & ", " & FName
      End If
      n = n + 1
   Next
   If m_iNumSumFields > 0 Then
      n = 0
      For i = 0 To m_iNumSumFields - 1
         iField = m_pTable.Fields.FindField(lbSummaryFields.List(i))
         FName = m_pTable.Fields.Field(iField).Name
         ReDim Preserve m_SumFNames(n)
         m_SumFNames(n) = FName
         n = n + 1
      Next
   End If
   
    ' Get table to create
   
   Dim CDLG As ComDlg
   Dim OutDir As String, OutFile As String
   Set CDLG = New ComDlg
   With CDLG
      .DialogTitle = "Save Table As"
      .FileName = "Export_Frequency"
      .Extension = "dbf"
      Dim f(1) As String
      f(0) = "DBF (*.dbf)|*.dbf"
      f(1) = "All Files (*.*)|*.*"
      .Filter = f
      .FilterIndex = 0
      .ExistFlags = PathMustExist
      bResult = .ShowSave
      If Not bResult Then
         Exit Sub
      End If
      OutDir = .Directory
      OutFile = .FileTitle
   End With
   Set CDLG = Nothing
   OutDir = LCase(OutDir) ' This avoids a bizarre ArcObjects bug
   
  ' Create output table
   
   Dim pOutTable As ITable
   Set pOutTable = CreateTable(OutDir, OutFile)
   
   ' Check for selection set
   
   Dim bUseSel As Boolean
   Dim pTSel As ITableSelection
   Dim pSS As ISelectionSet
   
   bUseSel = False
   Set pTSel = m_pTable
   Set pSS = pTSel.SelectionSet
   i = pSS.Count
   bUseSel = (i > 0)
   
   ' Check for definition query
   
   Dim bUseQF As Boolean
   Dim pTD As ITableDefinition
   Dim Tmp As String
   Dim pQF As IQueryFilter
   
   bUseQF = False
   If (Not bUseSel) Then
      Set pTD = m_pTable
      Tmp = pTD.DefinitionExpression
      If Tmp <> "" Then
         Set pQF = New QueryFilter
         pQF.WhereClause = Tmp
         bUseQF = True
      End If
   End If
   
   ' Sort table
   
   Application.StatusBar.Message(0) = "Sorting..."
   DoEvents
   Dim pTS As ITableSort
   Set pTS = New TableSort
   With pTS
      .Fields = FieldString
      Set .Table = m_pTable
      For i = 0 To m_iNumSortFields - 1
         .Ascending(m_SortFNames(i)) = True
         If cbCaseSensitive.Value Then
            .CaseSensitive(m_SortFNames(i)) = True
         End If
      Next
      If bUseSel Then
         Set .SelectionSet = pSS
      ElseIf bUseQF Then
         Set .QueryFilter = pQF
      End If
   End With
   pTS.Sort Nothing
   
   ' Set up summary reporting
   
   Dim Sums As Variant
   If m_iNumSumFields > 0 Then
      ReDim Sums(m_iNumSumFields - 1)
   End If
   
   ' Loop through rows
   
   Dim pCursor As ICursor
   Dim pRow1 As IRow, pRow2 As IRow
   Dim bDup As Boolean
   Dim iNumRecs As Long, iCount As Long
   
   Application.StatusBar.Message(0) = "Analyzing..."
   DoEvents
   Set pCursor = pTS.Rows
   Set pRow1 = pCursor.NextRow
   Set pRow2 = pCursor.NextRow
   iNumRecs = 0
   iCount = 1
   If m_iNumSumFields > 0 Then
      SetSums pRow1, Sums, iCount
   End If
   Do While Not pRow2 Is Nothing
   
      iNumRecs = iNumRecs + 1
      If iNumRecs Mod 100 = 0 Then
         Application.StatusBar.Message(0) = "Analyzing... " & iNumRecs
         DoEvents
      End If
      
      bDup = True
      For i = 0 To m_iNumSortFields - 1
         iField = m_pTable.FindField(m_SortFNames(i))
         If pRow1.Value(iField) <> pRow2.Value(iField) Then
            bDup = False
            Exit For
         End If
      Next
      If bDup Then
         iCount = iCount + 1
      Else
         InsertRow pOutTable, pRow1, Sums, iCount
         iCount = 1
      End If
      Set pRow1 = pRow2
      If m_iNumSumFields > 0 Then
         SetSums pRow1, Sums, iCount
      End If
      Set pRow2 = pCursor.NextRow
   
   Loop
   InsertRow pOutTable, pRow1, Sums, iCount
   
   ' Ask if add to view
   
   Dim Result
   Result = MsgBox("Add table to view?", vbYesNo)
   If Not Result = vbYes Then
      Exit Sub
   End If
   
   Dim pDoc As IMxDocument
   Dim pMap As IMap
   Dim pStTab As IStandaloneTable
   Dim pStTabColl As IStandaloneTableCollection
  
   Set pDoc = ThisDocument
   Set pMap = pDoc.FocusMap
   Set pStTab = New StandaloneTable
   Set pStTab.Table = pOutTable
   Set pStTabColl = pMap
   pStTabColl.AddStandaloneTable pStTab

   pDoc.UpdateContents
   
End Sub

Private Function CreateTable(OutPath, OutName) As ITable

   ' Delete file if it already exists
   
   Dim fs
   Dim FileSpec As String
   
   Set fs = CreateObject("Scripting.FileSystemObject")
   FileSpec = OutPath & "\" & OutName
   If fs.FileExists(FileSpec) Then
      fs.DeleteFile FileSpec
   End If
   
   ' Set up workspace and fields

   Dim pWSF As IWorkspaceFactory
   Dim pWS As IFeatureWorkspace
   Dim pFields As IFields
   Dim pFieldsEdit As IFieldsEdit
   Dim i As Long, iField As Long, n As Long
   Dim FName As String, FullName As String
   Dim pField As iField, pNewField As iField
   Dim pFieldEdit As IFieldEdit
   
   Set pWSF = New ShapefileWorkspaceFactory
   Set pWS = pWSF.OpenFromFile(OutPath, 0)
   Set pFields = New Fields
   Set pFieldsEdit = pFields
   n = m_iNumSortFields + m_iNumSumFields + 1
   pFieldsEdit.FieldCount = n
   Set m_OutFNames = CreateObject("Scripting.Dictionary")
   
   ' Add sort field(s)
 
   n = 0
   For i = 0 To m_iNumSortFields - 1
      FullName = m_SortFNames(i)
      iField = m_pTable.FindField(FullName)
      Set pField = m_pTable.Fields.Field(iField)
      FName = GetOutFName(FullName)
      Set pNewField = New Field
      Set pFieldEdit = pNewField
      With pFieldEdit
         .Name = FName
         .Type = pField.Type
         .Length = pField.Length
      End With
      Set pFieldsEdit.Field(n) = pNewField
      n = n + 1
   Next
 
   ' Add frequency field
 
   Set pNewField = New Field
   Set pFieldEdit = pNewField
   With pFieldEdit
      .Name = "frequency"
      .Type = esriFieldTypeInteger
   End With
   Set pFieldsEdit.Field(n) = pNewField
   n = n + 1
 
   ' Add summary field(s)
 
   If m_iNumSumFields > 0 Then
      For i = 0 To m_iNumSumFields - 1
         FullName = m_SumFNames(i)
         iField = m_pTable.FindField(FullName)
         Set pField = m_pTable.Fields.Field(iField)
         FName = GetOutFName(FullName)
         Set pNewField = New Field
         Set pFieldEdit = pNewField
         With pFieldEdit
            .Name = FName
            .Type = pField.Type
            .Length = pField.Length
         End With
         Set pFieldsEdit.Field(n) = pNewField
         n = n + 1
      Next
   End If
 
   ' Create table
   
   Dim pTable As ITable
   Set pTable = pWS.CreateTable(OutName, pFields, Nothing, Nothing, "")
   
   Set CreateTable = pTable

End Function

Private Sub SetSums(pRow As IRow, ByRef Sums As Variant, iCount As Long)

   Dim i As Long, iField As Long
   Dim FName As String
   Dim Val As Variant
   
   For i = 0 To m_iNumSumFields - 1
      FName = m_SumFNames(i)
      iField = m_pTable.FindField(FName)
      Val = pRow.Value(iField)
      If iCount = 1 Or IsNull(Sums(i)) Then
         Sums(i) = Val
      ElseIf Not IsNull(Val) Then
         Sums(i) = Sums(i) + Val
      End If
   Next
   
End Sub

Private Sub InsertRow(pTable As ITable, pRow As IRow, Sums As Variant, iCount As Long)
   
   Dim pOutRow As IRow
   Dim i As Long, iField As Long
   Dim FName As String, OutName As String
   Dim Val As Variant
   
   Set pOutRow = pTable.CreateRow
   
   ' Set sort value(s)
   
   For i = 0 To m_iNumSortFields - 1
      FName = m_SortFNames(i)
      iField = pRow.Fields.FindField(FName)
      Val = pRow.Value(iField)
      OutName = m_OutFNames.Item(FName)
      iField = pOutRow.Fields.FindField(OutName)
      pOutRow.Value(iField) = Val
   Next
   
   ' Set frequency value
   
   FName = "frequency"
   iField = pOutRow.Fields.FindField(FName)
   pOutRow.Value(iField) = iCount
   
   ' Set summary value(s)
   
   If m_iNumSumFields > 0 Then
      For i = 0 To m_iNumSumFields - 1
         FName = m_SumFNames(i)
         Val = Sums(i)
         OutName = m_OutFNames.Item(FName)
         iField = pOutRow.Fields.FindField(OutName)
         pOutRow.Value(iField) = Val
      Next
   End If
   
   pOutRow.Store

End Sub

Private Function GetOutFName(FullName As String)
      
   If m_OutFNames.Exists(FullName) Then
      MsgBox "Duplicate field name encountered.", vbExclamation
      End
   End If
   
   Dim FName As String
   Dim iField As Long
   
   iField = InStr(1, FullName, ".")
   If iField > 0 Then
      iField = Len(FullName) - iField
      FName = Right(FullName, iField)
   Else
      FName = FullName
   End If
   If Len(FName) > 10 Then
      FName = Left(FName, 10)
   End If
   
   Dim bUnique As Boolean
   Dim i As Long, iUpper As Long, iCount As Long
   Dim s As String, OutName As String
   Dim a
   
   bUnique = False
   a = m_OutFNames.Items
   iUpper = m_OutFNames.Count - 1
   iCount = 1
   OutName = FName
   Do While bUnique = False
      bUnique = True
      For i = 0 To iUpper
         If a(i) = OutName Then
            bUnique = False
            Exit For
         End If
      Next
      If Not bUnique Then
         s = CStr(iCount)
         i = Len(FName) + Len(s)
         If i > 10 Then
            i = 10 - Len(s)
            OutName = Left(FName, i) + s
         Else
            OutName = FName + s
         End If
      End If
   Loop
   m_OutFNames.Add FullName, OutName
   GetOutFName = OutName

End Function
